/*Kamil Kukoowicz 	grupa studencka: TIZ
   09.12.2008
*/

/* min_element()  -  zwraca iterator ustawiony na element najmniejszy, z zakresu [elt poczatkowy, elt koncowy );
			elt poczatkowy i elt kocowy sa iteratorami, elt kocowy nie naley do zakresu
   max_element()  -  zwraca iterator ustawiony na element najwikszy, z zakresu [elt poczatkowy, elt koncowy );
			elt poczatkowy i elt kocowy sa iteratorami, elt kocowy nie naley do zakresu
*/

/*
Wersja pierwsza przyjmuje jako parametry zakres
 template <class ForwardIterator>
	ForwardIterator min_element ( ForwardIterator first, ForwardIterator last );
	ForwardIterator max_element ( ForwardIterator first, ForwardIterator last );

Wersja druga przyjmuje jako parametry zakres oraz funkcj porwnujc obiekty
 template <class ForwardIterator, class Compare>
	ForwardIterator min_element ( ForwardIterator first, ForwardIterator last, Compare comp );
	ForwardIterator max_element ( ForwardIterator first, ForwardIterator last, Compare comp );
*/

#include <stdio.h>
#include <iostream>
#include <string>
#include <list>

using namespace std;

/*funkcja porwnujca dwa obiektu typu string, funkcja zwraca true,  jezeli obiekt i jest krtszy od obiektu j*/
bool myFunction(string i, string j) {
		return  i.length()<j.length();
}

/*wasna klasa zawierajca deklaracj operatora mniejszoci "<"*/
class myPoint {
public:
	int x;
	int y;
	myPoint(int x_init = 0, int y_init =0 ){ x=x_init; y=y_init; } ;

	/*operator porwnania "<" zwraca true jeli wsprzdna "x" obiektu po lewej stronie operatora "<"
	jest mniejsza od wsprzdnej "x" obiektu stocego po prawej stronie operatora "<"*/
	bool operator<(myPoint p2)
	{
		return x<p2.x;
	}
};

/*wasna funkcja porwnanujca obiekty typu myPoint
   zwraca true jeli wsprzdna "y" pierwszego obiektu jest mniejsza od wsprzdnej "y" drugiego obiektu
 */
bool myPointComparator(myPoint p1, myPoint p2)
{
return p1.y<p2.y;
};

int main(){

/*stwrz list stringw i dwa interatory mogce wskazywa pozycj w licie*/
list<string> names;
list<string>::iterator listIterator;
list<string>::iterator listIterator2;

/*dodaj kilka imion do listy*/
names.push_back("Kamil");
names.push_back("Jan");
names.push_back("Bartek");
names.push_back("Zenon");
names.push_back("Grzegorz");

/*min_element zwrci pozycj najmniejszego elementu z caej listy, czyli "Bartek"*/
listIterator = min_element(names.begin(), names.end());
cout<<"\nNajmniejsze leksykograficznie imie z calej listy: "<<*listIterator<<endl;

/*max_element zwrci pozycj najwikszego elementu z caej listy, czyli "Zenon"*/
listIterator = max_element(names.begin(), names.end());
cout<<"\nNajwieksze leksykograficznie imie z calej listy: "<<*listIterator<<endl;

/*ustaw iterator tak aby wskazywa na Bartek*/
listIterator2 = names.begin();
listIterator2++;
listIterator2++;

/*min_element zwrci pozycj najmniejszego elementu z przedziau [Kamil, Bartek), czyli Jan, bo Bartek nie jest brany pod uwag*/
listIterator = min_element(names.begin(), listIterator2 );
cout<<"\nKoncowy kraniec zakresu: "<<*listIterator2<<endl;
cout<<"Najmniejsze leksykograficznie imie z podanego zakresu: "<<*listIterator<<endl;

/*ustaw iterator tak aby wskazywa?na Zenon*/
listIterator2 = names.begin();
listIterator2++;
listIterator2++;
listIterator2++;

/*max_element zwrci pozycj najwikszego elementu z przedziau [pierwsze imie, Zenon), czyli "Kamil" bo Zenon nie jest brany pod uwag*/
listIterator = max_element(names.begin(), listIterator2 );
cout<<"\nKoncowy kraniec zakresu: "<<*listIterator2<<endl;
cout<<"Najwieksze leksykograficznie imie z podanego zakresu: "<<*listIterator<<endl;

/*min_element wykorzysta do porwnania funkcj podan jako parametr
  Funkcja ta porwnuje dugo stringa */
listIterator = min_element(names.begin(), names.end(), myFunction);
cout<<"\nNajkrotsze imie z calej listy (wykorzystano wlasna funkcje porownania): "<<*listIterator<<endl;


/*lista punktw i iterator do tej listy*/
list<myPoint> points;
list<myPoint>::iterator pointsIterator;

/*stwrz kilka punktw*/
myPoint* p1 = new myPoint(2,3);
myPoint* p2 = new myPoint(1,2);
myPoint* p3 = new myPoint(3,1);

/*Dodaj punkty do listy - argumentem push_back() musi byc referencj lub obiektem, a nie wskanikiem.
W licie przechowywane s kopie obiektw*/
points.push_back(*p1);
points.push_back(*p2);
points.push_back(*p3);

/*funkcja min_element zwrci pozycj punktu (1,2) jako najmniejszy z listy, wykorzystany jest operator zadeklarowany w klasie*/
pointsIterator = min_element(points.begin(), points.end());
cout<<"\nNajmniejszy punkt (operator '<' zdefiniowany w klasie): ("<<pointsIterator->x<<","<< pointsIterator->y <<")"<<endl;

/*funkcja min_element zwrci pozycj punktu (3,1) jako najmniejszy z listy, wykorzystany jest zewntrzn funkcja porwnujc*/
pointsIterator = min_element(points.begin(), points.end(), myPointComparator);
cout<<"Najmniejszy punkt (wlasna funkcja porownujaca): ("<<pointsIterator->x<<","<< pointsIterator->y <<")"<<endl;

return 1;
}

